/* PROTO.H - Deklaration av funktioner */
/* (c) 1991 Nils Hammar */

void	exit(int);

/*	FILHANT.C */

void	upper(char *, char *);
void	lower(char *, char *);
int	nameconv(char *, char *);
int	getmoeten(void);
void	putmoeten(int);
int	getmaxtext(int);
void	putmaxtext(int, int);
int	gettextindex(int, int);
int	puttextindex(int);
void	storetext(char *);
void	gettxt(unsigned char *, int);
void	showtext(int, int);
int	skapamoete(void);
int	instring(char *, char *);
int	getmoetnumber(char *, int);
int	getusers(void);
int	getuserinfo(int);
int	putuserinfo(int);
void	logg(unsigned char *, unsigned int);

/*	MAINT.C */

int	userfind(char *);
void	editother(int);
void	editmyself(void);
void	edituser(char *);
char	*getuserid(char *, int);
void	showuser(char *);
void	listusers(char *);
void	setpassword(char *);
void	connect(char *, int);
void	privlist(int, char *, int);
void	priv(int, char *, char *, char *);
void	showmeetpar(char *);
void	setmeetpar(int, char *, char *);
void	setuserpar(int, char *, char *);
void	showallow(char *);
void	show(char *, char *);
void	setpar(char *, char *, char *);
void	clearpar(char *, char *, char *);
void	packmeet(char *, char *);
void	sysedit(void);
void	meetedit(char *);
void	whoami(void);
void	adduser(int, char *);
void	prompt(int, char *);
void	defprivlist(int);
void	defpriv(int, char *, char *);
void	deleteusr(char *);
void	point(unsigned int, char *);
int	numedit(char *, int, int);
void	cleanusers();

/*	TEXTHANT.C */

void	listmeetings(char *);
void	member(char *);
void	nomember(char *);
void	whereami(void);
int	getgomoete(int, int);
void	gotomoete(char *);
void	nastamoete(void);
void	readtext(char *);
void	writetext(void);
void	questiontext(void);
void	personaltext2(char *);
void	personaltext(char *);
void	persquesttext2(char *);
void	persquesttext(char *);
void	perskommtext(char *);
int	dokommtext(char *, int);
void	pubquest(void);
void	endast(char *);
void	kommtext(char *);
void	deletemoete(char *);
void	deletetext(char *);
void	scanmail(char *);
void	readmail(void);
void	subjectlist(void);
void	stattext(char *, char *);
void	status(char *, char *, char *);
void	statuser(char *);
void	statmeet(char *);
void	statmail(void);
void	movetext(char *);
void	dowritetext(int, int, char *, int, char *);
int	writetextpriv(int);
void	texthead(char *, int, int, char *);
void	textinfohead(char *, char *, int, char *);
void	kludgeadd(char *, int, int, char *, char *, int, int, int, int);
void	textend(char *);
void	concattext(char *, char *);
void	savetext(char *);
void	tempstoreold(unsigned char *);

/*	LOGIN.C */

void	newuser(void);
int	login(void);
void	updateuser(int);
int	mainloop(void);
void	enterprogram(void);
void	exitprogram(void);
int	main(int, char **);
int	fortune(void);
void	logoff(int);
void	loadeditors(char *);
void	loadcommands(void);

/*	INTERPRE.C */

int	searchcmnd(char *);
int	maincommands(int);
int	maintcommands(int);
int	msgcommands(int);
void	listcommands(void);
void	msgdefaultact(void);
int	maxtime(void);
int	interpret(void);

/*	TIDEN.C */

/*	Tiden kan antingen redovisas enligt ISO (1990-06-01 20:00:00)
	eller i USA-format (12 Apr 90 12:33:40)
	Drav har vi 4 olika rutiner.
	Lokal tid r beroende av environmentvariabeln TZ. */

void			tidkonv(long int *, char *);  /* GMT i ISO-format */
void			ftidkonv(long int *, char *); /* GMT i USA-format */
void			dtidkonv(unsigned int, unsigned int, char *);
void			tidkonvl(long int *, char *); /* Lokal tid, ISO */
void			ftidkonvl(long int *, char *); /* Lokal tid, USA */
void			tiden(char *);
void			ftiden(char *);
void			tidenl(char *);
void			ftidenl(char *);
void			timediff(void);
#ifndef __TURBOC__
void			sleep(int);
#endif
void			tidkonv2(unsigned long int, char *);
unsigned long int	ftimetol(char *);
unsigned long int	itimetol(char *);
unsigned long int	dtimetol(unsigned int, unsigned int);
int			dayofweek(void);
int			dayofyear(void);
int			hourofday(void);

/*	LINEED.C */

/* JANNE */

int      	fosgetch(void);
void     	process_kbd(void);
void     	process_ser(void);
int		ansi_check(char * );

unsigned char	transchar(unsigned char, int, int);
/* unsigned int	fosgetch(void); */
void		fosputch(unsigned char);
void		fpr(char *);
void		efpr(char *);
void		newline(void);
int		delchar(char *, int);
int		dellin(char *, int);
void		redispline(char *, char *, int, int);
int		pcfunktan(void);
int		termfunktan(void);
int		lineed(char *, char *, char *, int, int);
void		operator(void);
void		efosputch(unsigned char);
void		showuserinfo(void);

/*	FOSSIL.C */

unsigned int	initfossil(void);
unsigned int	deinitfossil(void);
unsigned int	baudfossil(unsigned int, unsigned int,
			unsigned int, unsigned int);
unsigned int	statusfossil(void);
void		txchwfossil(unsigned char);
unsigned int	rxchwfossil(void);
unsigned int	rxchfossil(void);
void		dtronfossil(void);
void		dtroffossil(void);
void		puinfossil(void);
unsigned int	kbdrdfossil(void);
unsigned int	kbdrdwfossil(void);
void		fcfossil(int);
int		noctrlcfossil(void);
void		curfossil(int, int);
int		getcurfossil(void);
void		ansiwritefossil(int);
void		bioswritefossil(int);
void		wdonfossil(void);
void		wdoffossil(void);
void		rebootfossil(int);
void		startbrkfossil(void);
void		stopbrkfossil(void);
int		keytest(void);

/*	NODES.C */

void	stripout(unsigned char *, unsigned char *, int, int);
void	scanlist(void);
void	listnodes(char *);
void	listnets(char *);
int	getnodeinfo(char *);
int	getnodeinfo2(char *);
int	getnode(void);
int	getareainf(int);
int	putareainf(int);
void	extractmeet(char *);
void	scanareas(void);
void	listareas();
int	getmnodeinfo(char *);
void	listareas(void);
void	translate(char *, int, int);
int	subcompstr(char *, char *);
void	filetext(unsigned int, unsigned int, unsigned int, char *, unsigned int, unsigned int, char *, unsigned int);
void	extractmail(void);
void	extractecho(void);
int	loadtexts(FILE *, int, char *, FILE *);
void	loadfile(char *);
void	packecho(void);
void	loadecho(void);
void	textextract(int, char *, int);
void	addnodes(unsigned char *, unsigned char *,
		unsigned int *, unsigned int);
int	getaddinfo(char *);
void	addseens(char *, char *, int *);
int	areacomp(areastruct *, areastruct *);
int	parseorigin(char *, unsigned int *, unsigned int *,
		unsigned int *, unsigned int *);

/*	EDIT.C */

void	packtext(char *, int);
void	listtext(char *, int);
int	changeline(char *, int, int);
int	deleteline(char *, int, int);
int	insertline(char *, int, int);
void	listcommand(void);
int	commandline(char *, char *, int);
int	edittext(char *, int, char **);
void	mailfile(void);
int	insertfile(char *, char *, int);

/*	EDIT2.C	*/

unsigned int	cleantext(char *);
void		viewtext(unsigned char *, int);
void		viewtext2(unsigned char *, int, int);
int		edittext2(unsigned char *, int);

/*	FILES.C */

far	critical_err(unsigned int, unsigned int, unsigned far *);
void	showfile(char *, int);
void	strippath(char *, char *);
void	changedir(char *);
void	directory(char *, char *);
void	searchfile(char *);
void	typefile(char *);
void	archandle(char *, char *, char *, char *);
void	listarc(char *, char *);
void	transfer(char *, char *, char *);
void	upload(char *, char *);
void	download(char *, char *);
void	movefile(char *, char *);
void	deletefile(char *);
void	makedir(char *);
void	removedir(char *);
void	convert(char *, char *, char *);
void	pathway(void);
int	phystolog(char *, char *);
void	checkdisk(void);
void	volume(void);
void	loadunits(void);
int	findunit(void);
void	syscmd(char *);
void	request(char *, char *);
void	freefileinfo(char *);

/* JANNE */

/* ANSIEDIT.H */

#ifdef MSDOS
struct WINDOW
{
	int X1,Y1,X2,Y2;
} w;
#endif

char *startbuf, *endbuf, *curloc, *endloc;

int ansiedit(void);
void ed_display_scr(int  , int	, char * );
char *ed_display_line(int  , int  , char * );
void ed_cls(void);
void ed_pos(int  , int	);
void ed_insert_char(int    );
void ed_delete_char(void);
void ed_delete_line(void);
void ed_backspace(void);
int  ed_ptr_prev(int	);
int  ed_ptr_forward(int  );
int  ed_ptr_next(int	);
int  ed_ptr_end(void);
void ed_cursor_up(void);
void ed_cursor_down(void);
void ed_cursor_forward(void);
void ed_cursor_backward(void);
void ed_insert_lf(void);
void ed_putch(unsigned int );


/* BUFFER.C */

#define BUFSIZE 32

typedef struct {
   int status;
   int *head;
   int *tail;
   int *begin;
   int *end;
   int data[BUFSIZE];
   } BUF;

#define READLOCK    0x0001
#define WRITELOCK   0x0002
#define ZEROSTAT    0x0000
#define ALLSTAT     0xffff

BUF kbd_buf, ser_buf;

void init_buf(BUF * );
BUF *make_buf(unsigned int  );
unsigned int read_buf(BUF * );
int write_buf(BUF * , unsigned int  );
int write_buf_str(BUF * , char * );
int flush_buf(BUF * );
int status_buf(BUF * , int     , int  );
int look_buf_str(BUF * , char * );

#ifdef MSDOS
	far	critical_err();
	char	*appst(char * , char * );
	int	kolla(char *);
	int	compare(char *, char *);
	int	direntry(struct FILEINFO *, char *, int);
	int	dirlist(char *, char *);
	void	listdir(char *);
	int	getfileinfo(char *, char *, int *);
	int	putfileinfo(char *, char *, int);
	void	editinfo(char *);
	int	fileinfo(char *, char *);
#endif

/*	ROUTE.C */

int	nodeanalyze(int, int, int, int);
void	reroute(char *, unsigned int, char *, char *);
void	checkfiles(char *, int, char *);
void	checkdirs(char *);
void	routelist(void);
void	packfiles(char *, int, char *);
void	packdirs(char *);
void	packlist(void);

/*	INQTERM.C */

int		testterm(char *, char *);
void		vtanalyze(char *);
int		inquireterminal(void);
